from .lumps.structure_parser import Struct

class VTXparser():
    def __init__(self, tf_path, filepath):
        self.__VTXheader = Struct("header",
                        (("version", "INTUL"),
                         ("filler", "RAW/16"),
                         ("numLODs", "INTUL"),
                         ("materialReplacementListOffset", "INTUL"),
                         ("numBodyParts", "INTUL"),
                         ("bodyPartOffset", "INTUL")))

        self.__bpartheader = Struct("bodypartheader",
                                (("numModels", "INTUL"),
                                 ("modelOffset", "INTUL")))

        self.__modelheader = Struct("modelheader",
                             (("numLODs", "INTUL"),
                              ("lodOffset", "INTUL")))

        self.__modellodheader = Struct("modellodheader",
                                (("numMeshes", "INTUL"),
                                ("meshOffset", "INTUL"),
                                ("switchPoint", "FLOATUL")))

        with open(filepath, "rb") as fp:
            data = self.__VTXheader.parse(fp)
            fp.seek(data["bodyPartOffset"])
            
            self.__bpartheader.parse(fp)
            self.__modelheader.parse(fp)
            mloddata = self.__modellodheader.parse(fp)
        self.__nmaterials = mloddata["numMeshes"]

    def get_nmaterials(self):
        return self.__nmaterials
        
